// Visualizacin paisaje con molino de caractersticas basadas en
// el edificio conocido como "El Polvorn" en Sigenza. 
// Probado con la versin 3.1g de Pov-Ray
#include "colors.inc"
#include "skies.inc" 

//                           / \
//         ^                /   \
//       Y |               /-----\
//         |               |     |
//         | / Z           |  -  |
//         |/              | | | |
//         +-----> X       | | | |                        
//      
//   location <-X,1,0>         vista desde el "oeste geogrfico"   a X m de distancia
//   location <X,1,0>          vista desde el "este  geogrfico"   " " "  "    "
//   location <0,1,-Z>         vista desde el "sur   geogrfico"   " Z "  "    "
//   location <0,1,Z>          vista desde el "norte geogrfico"   " Z "  "    "
//   location <0,Z,0>          vista desde lo arriba


// un "cielo nuboso" para hacer menos feo el tema. En este caso uso un cielo "prefabricado"
sky_sphere { S_Cloud1 }



camera {                    
// vista desde el sur
 location <0,4,-15>
 look_at <0,4,0>
}

// usaremos un area light source
light_source {
  <0, 50, -50>  // un sol ficticio, ilumina desde el sur
  color White
  area_light <5,0,0>, <0,0,5>, 5, 5
  adaptive 1
  jitter
}
   
// un suelo, para que se apoye el molino en alguna parte   
plane {
  <0,0.5,0> 0                
  texture {      
        pigment { color Green }
  }
}  



// ZONA DE DEFINICIONES "externas" PARA MOLINO. NO SON IMPRESCINDIBLES.
// Permiten variar los valores por omisin.
#declare encarar_viento = 0;      // angulo que debe rotar la parte mvil del molino para
                                   // encarar el viento. Posibles valores:     
                                   //   0 --> viento procedente del este
                                   //  90 --> viento procedente del "sur geogrfico" (puerta y ventana)
                                   // 180 -->    "       "       "  oeste
                                   // 270 -->    "       "       "  norte
// angulo de apertura puerta molino
//   0 --> cerrada
//  45 --> entreabierta hacia afuera
// -45 --> entreabierta hacia adentro                                   
#declare Apertura_puerta = -30;                                   

                                                                         
#include "windmill.inc"

// por defecto dejamos todo como est
#declare rotar_conjunto_x = 0;
#declare rotar_conjunto_y = 0;
#declare rotar_conjunto_z = 0;
#declare mover_conjunto_x = 0;
#declare mover_conjunto_y = 0;
#declare mover_conjunto_z = 0;
#declare Factor_escala_conjunto = 1.0;   
#declare factor_giro_aspas = 1.0;


// El molino tambin se puede instanciar por sus partes ("Paredes" y "Resto"), para 
// poder manipularlas por separado.

// "Paredes" corresponde a la "parte inmvil" del molino
//object { Paredes 
//   translate <mover_conjunto_x,mover_conjunto_y, mover_conjunto_z>
//   rotate <rotar_conjunto_x,rotar_conjunto_y,rotar_conjunto_z>
//   scale Factor_escala_conjunto }

// "Conjunto_completo" corresponde a las "partes mviles"
//object { Resto 
//   translate <mover_conjunto_x,mover_conjunto_y, mover_conjunto_z>
//   rotate <rotar_conjunto_x,rotar_conjunto_y,rotar_conjunto_z>
//   scale Factor_escala_conjunto }
   
object { Molino 
   translate <mover_conjunto_x,mover_conjunto_y, mover_conjunto_z>
   rotate <rotar_conjunto_x,rotar_conjunto_y,rotar_conjunto_z>
   scale Factor_escala_conjunto }